package aspectjtest;

import java.util.HashSet;
import java.util.Set;







public abstract aspect TranslatableDefaultImpl<PARENT, CHILD> {

	
	@SuppressWarnings("rawtypes")
	public interface ChildHasParent<PARENT extends ParentHasChildren> {

		int getCategoryId();

		void setCategoryId(int categoryId);

		PARENT getParent();

		void setParent(PARENT entity);

	}
	
	@SuppressWarnings("rawtypes")
	public static  interface ParentHasChildren<CHILD extends ChildHasParent> {

		public void addChild(CHILD child);

		public Class<CHILD> getChildrenClass();

		public Set<CHILD> getChildren();

		public CHILD getChild(Integer categoryId);

		public void setChildren(Set<CHILD> children);
	}
	
	
//	declare parents: PARENT implements ParentHasChildren<CHILD>;
//	declare parents: CHILD implements ChildHasParent<PARENT>;
	
	
	
	
	private int ChildHasParent<P>.categoryId;

	private P ChildHasParent<P>.parent;

	
	public int ChildHasParent<P>.getCategoryId() {
		return categoryId;
	}

	public void ChildHasParent<P>.setCategoryId(int categoryId) {
		this.categoryId = categoryId;
	}

	public P ChildHasParent<P>.getParent() {
		return parent;
	}

	public void ChildHasParent<P>.setParent(P parent) {
		this.parent = parent;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	private java.util.Set<C> ParentHasChildren<C>.children;
	
	
	
	public void ParentHasChildren<C>.addChild(C child) {
		Set<C> children = this.getChildren();
		if(children == null) {
			children = new HashSet<C>();
			setChildren(children);
		}
		children.add(child);
	}

	public java.util.Set<C> ParentHasChildren<C>.getChildren() {
		return this.children;
	}

	public void ParentHasChildren<C>.setChildren(java.util.Set<C> children) {
		this.children = children;
	}

	public C ParentHasChildren<C>.getChild(java.lang.Integer categoryId) {
		if (this.children == null) {
			return null;
		} else {
			C result = null;

			for (C child : children) {
				if (child.getCategoryId() == categoryId) {
					result = child;
					break;
				}
			}

			return result;
		}
	}

}

